// Calculadora con la libreria WX
// SETA43
// windows -linux 

#include <wx/wx.h>

#include "define.h"
#include "port.h"
 
 
char VARI[100];
int  ContadorI=0;
char Binput[100];
char Binput2[10];
int tiempo2=10,tiempo1=5;

int canal,frecuencia;
float frecu;

unsigned char portok;

void  analizarIN();
int SearchPort();
 

class MiAplicacion : public wxApp
{
public:
    virtual bool OnInit();
};

class MiFrame: public wxFrame
{
public:
    MiFrame(wxWindow* parent,wxWindowID id = -1);
    
private:
	
    DECLARE_EVENT_TABLE()

    void OnQuit(wxCommandEvent& event) {PrintSerial((char *)"volume=0\n");CloseRs232(); Close();}
    void OnAbout(wxCommandEvent& event)
            {
                wxString msg;
                msg.Printf(wxT("Programa\nxsetaseta@gmail.com\n%s"),    wxVERSION_STRING);
                wxMessageBox(msg, wxT("SETA43"), wxOK | wxICON_INFORMATION, this);
            }
   void buscarmenos(wxCommandEvent& event);
   void buscarmas(wxCommandEvent& event);
   void canalmenos(wxCommandEvent& event);
   void canalmas(wxCommandEvent& event);
   void volumemenos(wxCommandEvent& event);
   void volumemas(wxCommandEvent& event);
   void init(wxCommandEvent& event);

   void MiTimer(wxTimerEvent& event);

	 wxTextCtrl* TextCtrl1;
	 wxTextCtrl* TextCtrl2;
	 wxStaticText* StaticText1;
	 wxStaticText* StaticText2;
	 wxStaticText* StaticText3;
	 wxStaticText* StaticText4;
	 
	 wxButton* Button1;
	 wxButton* Button2;
	 wxButton* Button3;
	 wxButton* Button4;
	 wxButton* Button5;
	 wxButton* Button6;
	 wxButton* Button7;
	 wxButton* Button8;
    
	 wxComboBox* ComboBox1;
};



bool MiAplicacion::OnInit()
{
    MiFrame* Frame = new MiFrame(0);       
    Frame->Show();
    return true;
}


DECLARE_APP(MiAplicacion)
// Give wxWidgets the means to create a MiAplicacion object
IMPLEMENT_APP(MiAplicacion)

BEGIN_EVENT_TABLE(MiFrame,wxFrame)  
	
	EVT_BUTTON(1020, MiFrame::buscarmenos)
	EVT_BUTTON(1021, MiFrame::buscarmas)
	EVT_BUTTON(1022, MiFrame::canalmenos)
	EVT_BUTTON(1023, MiFrame::canalmas)
	EVT_BUTTON(1024, MiFrame::volumemenos)
	EVT_BUTTON(1025, MiFrame::volumemas)
	EVT_BUTTON(1026, MiFrame::init)
	
	EVT_TIMER(1000, MiFrame::MiTimer)
	
	EVT_BUTTON(wxID_EXIT, MiFrame::OnQuit)
    
END_EVENT_TABLE();

MiFrame::MiFrame(wxWindow* parent,wxWindowID id)
{
 wxString msg;
    Create(parent, id,  _("RadioARDU"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE & ~(wxRESIZE_BORDER | wxMAXIMIZE_BOX));
    SetClientSize(wxSize(291,143));
	this->SetBackgroundColour( wxColour( 255, 255, 128 ) );
  
  TextCtrl1 = new wxTextCtrl(this, 1010, _("No "), wxPoint(8,8), wxSize(72,32), wxTE_READONLY|wxTE_RIGHT, wxDefaultValidator, _T("ID_TEXTCTRL1"));
  TextCtrl1->SetFont(wxFont(14, wxDEFAULT, wxNORMAL, wxNORMAL, 0, wxT("")));
  TextCtrl2 = new wxTextCtrl(this, 1010, _("--"), wxPoint(8,40), wxSize(32,24), wxTE_READONLY|wxTE_RIGHT, wxDefaultValidator, _T("ID_TEXTCTRL2"));
  
  StaticText1 = new wxStaticText(this, 1010, _("MHz"), wxPoint(88,24), wxDefaultSize, 0, _T("ID_STATICTEXT1"));
  StaticText2 = new wxStaticText(this, 1010, _("Canal"), wxPoint(48,48), wxDefaultSize, 0, _T("ID_STATICTEXT2"));
  StaticText3 = new wxStaticText(this, 1010, _("RadioArdu_wx"), wxPoint(176,8), wxDefaultSize, 0, _T("ID_STATICTEXT3"));
  StaticText4 = new wxStaticText(this, 1010, _("Vol"), wxPoint(216,80), wxSize(24,14), 0, _T("ID_STATICTEXT4"));

  Button6 = new wxButton(this, 1025, _("+"), wxPoint(240,72), wxSize(40,24), 0, wxDefaultValidator, _T("ID_BUTTON6"));
  Button8 = new wxButton(this, wxID_EXIT, _("Exit"), wxPoint(216,104), wxSize(64,24), 0, wxDefaultValidator, _T("ID_BUTTON8"));
  Button7 = new wxButton(this, 1026, _("Init"), wxPoint(168,104), wxSize(40,24), 0, wxDefaultValidator, _T("ID_BUTTON7"));
  Button5 = new wxButton(this, 1024, _("-"), wxPoint(168,72), wxSize(40,24), 0, wxDefaultValidator, _T("ID_BUTTON5"));
   
  Button4 = new wxButton(this, 1022, _("<"), wxPoint(8,104), wxSize(64,24), 0, wxDefaultValidator, _T("ID_BUTTON4"));
  Button3 = new wxButton(this, 1023, _(">"), wxPoint(88,104), wxSize(64,24), 0, wxDefaultValidator, _T("ID_BUTTON3"));
  Button2 = new wxButton(this, 1021, _(">>"), wxPoint(88,72), wxSize(64,24), 0, wxDefaultValidator, _T("ID_BUTTON2"));
  Button1 = new wxButton(this, 1020, _("<<"), wxPoint(8,72), wxSize(64,24), 0, wxDefaultValidator, _T("ID_BUTTON1")); 

#if YesWindows	
	wxString __wxSingleChoiceDialogChoices_1[8] =
     {
    	_("com1"),_("com2"),_("com3"),_("com4"),_("com5"),_("com6"),_("com7"),_("com8")
     };
#else
    wxString __wxSingleChoiceDialogChoices_1[8] =
    {
        _("/dev/ttyUSB0"), _("/dev/ttyUSB1"),  _("/dev/ttyUSB2"), _("/dev/ttyACM0"), _("/dev/ttyACM1"), _("/dev/ttyACM2"), _("/dev/ttyS0"), _("/dev/ttyS1")
    };
#endif	
	ComboBox1 = new wxComboBox(this, wxID_ANY, wxT(""), wxPoint(152,32), wxSize(123,27), 6, __wxSingleChoiceDialogChoices_1, wxCB_DROPDOWN);
	ComboBox1->SetSelection(0);	

	Centre();	
	portok=0;
	wxTimer *MiTimer= new wxTimer();
    MiTimer->SetOwner(this, 1000);
    MiTimer->Start(50);	// 20 veces por Segundo
	
    if(-1<SearchPort())
		{
			if(0!=IniRs232())
				{
				printf("NO %s\n",MODEMDEVICE);
				msg.Printf(wxT("No existe puerto"));
				wxMessageBox(msg, wxT("ERROR"), wxOK | wxICON_INFORMATION, this);
				msg.Printf(wxT("No port"));  TextCtrl1->SetValue(msg);
				portok=0;
				}
			else
			{
				wxString string1(MODEMDEVICE, wxConvUTF8);	TextCtrl1->SetValue(msg);
				if(DEBUG) printf("SI %s\n",MODEMDEVICE);    		      
				portok=1;
			}	
		}	
	
} 


void MiFrame::buscarmenos(wxCommandEvent& event)
{
	PrintSerial((char *)"buscar-\n"); 
} 

void MiFrame::buscarmas(wxCommandEvent& event)
{
	PrintSerial((char *)"buscar+\n"); 	
}

void  MiFrame::canalmenos(wxCommandEvent& event)
{
	if(canal>0)		canal--;
	sprintf(VARI,"ncanal=%d\n",canal);
	PrintSerial(VARI); 
}
void  MiFrame::canalmas(wxCommandEvent& event)
{
	if(canal < 210) canal++;
	sprintf(VARI,"ncanal=%d\n",canal);
	PrintSerial(VARI); 	
}

void  MiFrame::volumemenos(wxCommandEvent& event)
{
	PrintSerial((char *)"volume-\n");			
}
void  MiFrame::volumemas(wxCommandEvent& event)
{
	PrintSerial((char *)"volume+\n");	
}

void  MiFrame::init(wxCommandEvent& event)
{
 wxString msg,string1;
	if(DEBUG) printf("Init\n");
	
#if YesWindows
                   if(hSerial)CloseRs232();
#else		
		           if(fdrs232)CloseRs232();
#endif		 
	
	msg=ComboBox1->GetStringSelection();
	strcpy( VARI, (const char*)msg.mb_str(wxConvUTF8) );
    MODEMDEVICE=VARI;

    if(0!=IniRs232())
    {
        printf("NO %s\n",MODEMDEVICE);
        msg.Printf(wxT("No existe puerto"));
        wxMessageBox(msg, wxT("ERROR"), wxOK | wxICON_INFORMATION, this);		
        msg.Printf(wxT("No port"));  TextCtrl1->SetValue(msg); 
        portok=0;
    }
    else
    {
		wxString string1(VARI, wxConvUTF8);	TextCtrl1->SetValue(msg);
		if(DEBUG) printf("SI %s\n",MODEMDEVICE);    		      
        portok=1;
    }	
}



void MiFrame::MiTimer(wxTimerEvent& event)
{
	
 int nbytes;
 
	tiempo1--;
	tiempo2--;	

// cada 0,5 segundos
if(portok==1 && tiempo2<0)
		{
			tiempo2=10;	
						
#if YesWindows
                    while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
		            while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif			
				{
					//printf("Leer %d -> %s\n",ContadorI,Binput2);	
					Binput[ContadorI]=Binput2[0];
					ContadorI++;
					if (Binput2[0] == '\n')
						{
							if(ContadorI<2)ContadorI=2;   
							Binput[ContadorI-2]=0;
							ContadorI=0;	
							if(DEBUG)printf("Leidos-> %s\n",Binput);
							sprintf(VARI,"%s",Binput);																		
							
							analizarIN();	
							sprintf(VARI,"%d",canal);	wxString string1(VARI, wxConvUTF8);  TextCtrl2->SetValue(string1);
							frecu=frecuencia;	frecu/=10;
							sprintf(VARI,"%.1f",frecu);	 wxString string2(VARI, wxConvUTF8); TextCtrl1->SetValue(string2);							
						} 
				}
		}	 
 
// cada 1 segundos ____________________________________________
	if(tiempo1<0)
		{
			tiempo1=20;
			if(DEBUG) printf("1S  portok=%d\n",portok);	
		}

}





void  analizarIN()
{
  //int zz;
	if(!strncmp(VARI,"Canal=",6))
		{
			strncpy(Binput2,VARI+6,4);
			canal=atoi(Binput2);			 
			if(DEBUG)printf("OK_Canal =%d \n",canal);
			goto salirpro;
		}
	if(!strncmp(VARI,"Frecuencia=",11)) 
		{
			strncpy(Binput2,VARI+11,4);
			frecuencia=atoi(Binput2);			 
			if(DEBUG)printf("OK_Frecuencia =%d \n",frecuencia);
			goto salirpro;
		}
	if(DEBUG)printf("->%s\n",VARI);
	salirpro:
	;
}


int SearchPort()
{
 int z,zz,nbytes;
 
 printf("Search serial\n");
 #if YesWindows
       for (z=0;z<11;z++)
 #else
       for (z=0;z<7;z++)
 #endif		
		{
		 MODEMDEVICE=myport[z];
		 if(DEBUG)printf("Port %s\n",MODEMDEVICE);
         if(0==IniRs232())
           {
               	wxMilliSleep(1000);
               	PrintSerial((char *)"\n\n"); 
               	wxMilliSleep(100);
               	PrintSerial((char *)"RADIO1=\n");
               	wxMilliSleep(100);
               	             
               ContadorI=0; 
               for(zz=0;zz<10;zz++)
                {
                    wxMilliSleep(200);
#if YesWindows
                    while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
		            while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif		
		                    {	
							 //if(DEBUG)printf("Leer %d -> %s\n",nbytes,Binput2);
                      		 Binput[ContadorI]=Binput2[0];
                         	 ContadorI++;
                         	 if (Binput2[0] == '\n')
                                {
			                     if(ContadorI<2)ContadorI=2;   
                                 Binput[ContadorI-1]=0;
                       	         ContadorI=0;	
                                 sprintf(VARI,"%s",Binput);
                                 //printf("==%s\n",VARI);
                                 if(!strncmp(VARI,"OK",2))
                                   {
                                    printf("Radio found at %s\n",MODEMDEVICE);
                                    CloseRs232();                                   
                                    return z;
                                   }			
                                }
                             }	  	  
                 }             
            }
		 CloseRs232();
		}
    printf("Radio no found \n");
    return -1;
}
