#include <stdio.h>
#include <stdlib.h>

#include "define.h"


#if YesWindows 
 #include <windows.h>
  #define BAUDRATEW CBR_9600
#else
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <fcntl.h>
 #include <termios.h>
 #define BAUDRATE B9600
#endif


#if YesWindows 
extern	char MODEMDEVICEdefault[];
extern HANDLE hSerial;
extern DCB dcbSerialParams;
extern    COMMTIMEOUTS time_out;
#else
extern	char MODEMDEVICEdefault[];
extern	struct termios newtermios;
extern	int fdrs232;
#endif


extern char *MODEMDEVICE; 


#if YesWindows  
int WriteSerie(HANDLE hSerial,char *c,int tamano);
int ReadSerie(HANDLE hSerial,char *c,int tamano);
#endif


//_________________________

#if YesWindows
    static 	char *myport[]= {"com1","com2","com3","com4","com5","com6","com7","com8","com9","\\\\.\\COM10","\\\\.\\COM11","\\\\.\\COM12"};
#else
	static char *myport[]= {(char *)"/dev/ttyUSB0", (char *)"/dev/ttyUSB1", (char *)"/dev/ttyACM0", (char *)"/dev/ttyACM1", (char *)"/dev/ttyACM2", (char *)"/dev/ttyS0", (char *)"/dev/ttyS1"};
#endif	



#ifndef _TEST_H       //  directivas de preprocesador estandares
#define _TEST_H       

//------------------------------------------------------------------
#ifdef __cplusplus      //  Estas tres lineas
extern "C" {              //  son parte de lo que 
#endif                     //  nos permite usar nuestro código en c y c++
// ------------------------------------------------------------------
extern int IniRs232();
extern int CloseRs232();

extern  void PrintSerial(char *cadena);

//float calcMitad(int x);     // Declaración de nuestras funciones

//------------------------------------------------------------------
#ifdef __cplusplus       // estas tres lineas deben cerrar
}                              // las directivas de arriba
#endif
//------------------------------------------------------------------

#endif                     // directiva que cierra el ifndef principal


